<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	if (!defined('_PS_VERSION_'))
		exit;
			
	require_once(_PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkAPI.php");
	require_once(_PS_ROOT_DIR_ . "/modules/polarislink/models/PolarisLinkPhotos.php");	
	
	/*
	 * Obtient des informations sur les photos préalablement transmises
	 *
	 */
	class PolarisLinkAPI_PhotoInfoModuleFrontController extends PolarisLinkAPI
	{		
		protected function runAPI()
		{
			// Surtout plus de cache !!!
			Db::getInstance()->disableCache();

			// Lecture des informations à trouver depuis le corps de la requête ...
			$photosList = array();
			
			$sourceData = null;
			if (!isset($_SERVER["CONTENT_TYPE"]) || $_SERVER["CONTENT_TYPE"] == "")			
			{
				// Autodétection
				$tmpStream = fopen("php://temp", "r+");
				$argsStream = fopen("php://input", "r");
				
				stream_copy_to_stream($argsStream, $tmpStream);
				fseek($tmpStream, 0, SEEK_SET);				
				$header = fread($tmpStream, 2);				
				fseek($tmpStream, 0, SEEK_SET);
				
				$sourceData = stream_get_contents($tmpStream);				
				if ( strlen($header) == 2 && (ord($header[0]) == 0x1f && ord($header[1]) == 0x8b) )
				{
					// zip ...
					$sourceData = gzdecode($sourceData);
				}
				
				fclose($tmpStream);
				fclose($argsStream);				
			}
			else
				$sourceData = file_get_contents(($_SERVER["CONTENT_TYPE"] == "application/gzip" ? "compress.zlib://" : "").'php://input');
			
			foreach (explode(',', $sourceData) as $id)
			{
				$v = trim($id);
				if (!empty($v))
				{
					if (!ctype_digit($v))
						throw new Exception("Erreur de format");
					
					$idn = intval($v);
					if ($idn > 0)
						$photosList[] = $idn;
				}
			}
			
			// Obtient la liste des photos du système, avec leur ETag
			$response = array();
			
			$query = "SELECT id_polaris, etag FROM "._DB_PREFIX_."polarislink_photos WHERE id_link = ".$this->Link->LinkID;			
			if (count($photosList) > 0)
				$query .= " AND id_polaris IN (".implode(",", $photosList).")";

			$db = Db::getInstance();
			if ($rows = $db->ExecuteS($query))
			{
				foreach ($rows as $row)
				{
					if (file_exists(PolarisLinkAPI::GetPolarisPhotoPathFor($this->Link->LinkID, $row["id_polaris"])))
						$response[] = $row;
				}
			}

			$this->answerJSON($response);
			
			return true;
		}
	}
 